Loading...
Searching...
No Matches
IEEE 802.1D bridge
NETIFs

## Topics

| Options
| FDB example code

## Data Structures

struct | bridgeif_initdata_s

## Macros

#define | BRIDGEIF_INITDATA1(max_ports, max_fdb_dynamic_entries, max_fdb_static_entries, ethaddr)
#define | BRIDGEIF_INITDATA2(max_ports, max_fdb_dynamic_entries, max_fdb_static_entries, e0, e1, e2, e3, e4, e5)

## Typedefs

typedef struct bridgeif_initdata_s | bridgeif_initdata_t

## Functions

err_t | bridgeif_fdb_add (struct netif *bridgeif, const struct eth_addr *addr, bridgeif_portmask_t ports)
err_t | bridgeif_fdb_remove (struct netif *bridgeif, const struct eth_addr *addr)
err_t | bridgeif_init (struct netif *netif)
err_t | bridgeif_add_port (struct netif *bridgeif, struct netif *portif)

## Detailed Description

This file implements an IEEE 802.1D bridge by using a multilayer netif approach (one hardware-independent netif for the bridge that uses hardware netifs for its ports). On transmit, the bridge selects the outgoing port(s). On receive, the port netif calls into the bridge (via its netif->input function) and the bridge selects the port(s) (and/or its netif->input function) to pass the received pbuf to.

Usage:

- add the port netifs just like you would when using them as dedicated netif without a bridge
  - only NETIF_FLAG_ETHARP/NETIF_FLAG_ETHERNET netifs are supported as bridge ports
  - add the bridge port netifs without IPv4 addresses (i.e. pass 'NULL, NULL, NULL')
  - don't add IPv6 addresses to the port netifs!
- set up the bridge configuration in a global variable of type 'bridgeif_initdata_t' that contains
  - the MAC address of the bridge
  - some configuration options controlling the memory consumption (maximum number of ports and FDB entries)
  - e.g. for a bridge MAC address 00-01-02-03-04-05, 2 bridge ports, 1024 FDB entries + 16 static MAC entries: bridgeif_initdata_t mybridge_initdata = BRIDGEIF_INITDATA1(2, 1024, 16, ETH_ADDR(0, 1, 2, 3, 4, 5));
- add the bridge netif (with IPv4 config): struct netif bridge_netif; netif_add(&bridge_netif, &my_ip, &my_netmask, &my_gw, &mybridge_initdata, bridgeif_init, tcpip_input); NOTE: the passed 'input' function depends on BRIDGEIF_PORT_NETIFS_OUTPUT_DIRECT setting, which controls where the forwarding is done (netif low level input context vs. tcpip_thread)
- set up all ports netifs and the bridge netif
- When adding a port netif, NETIF_FLAG_ETHARP flag will be removed from a port to prevent ETHARP working on that port netif (we only want one IP per bridge not per port).
- When adding a port netif, its input function is changed to call into the bridge.

## Macro Definition Documentation

## BRIDGEIF_INITDATA1

#define BRIDGEIF_INITDATA1 | ( |  | max_ports,
|  |  | max_fdb_dynamic_entries,
|  |  | max_fdb_static_entries,
|  |  | ethaddr )

Value:
{ethaddr, max_ports, max_fdb_dynamic_entries, max_fdb_static_entries}

Use this for constant initialization of a bridgeif_initdat_t (ethaddr must be passed as ETH_ADDR())

## BRIDGEIF_INITDATA2

#define BRIDGEIF_INITDATA2 | ( |  | max_ports,
|  |  | max_fdb_dynamic_entries,
|  |  | max_fdb_static_entries,
|  |  | e0,
|  |  | e1,
|  |  | e2,
|  |  | e3,
|  |  | e4,
|  |  | e5 )

Value:
{{e0, e1, e2, e3, e4, e5}, max_ports, max_fdb_dynamic_entries, max_fdb_static_entries}

Use this for constant initialization of a bridgeif_initdat_t (each byte of ethaddr must be passed)

## Typedef Documentation

## bridgeif_initdata_t

typedef struct bridgeif_initdata_s bridgeif_initdata_t

Initialisation data for bridgeif_init. An instance of this type must be passed as parameter 'state' to netif_add when the bridge is added.

## Function Documentation

## bridgeif_add_port()

err_t bridgeif_add_port | ( | struct netif * | bridgeif,
|  | struct netif * | portif )

Add a port to the bridge

## bridgeif_fdb_add()

err_t bridgeif_fdb_add | ( | struct netif * | bridgeif,
|  | const struct eth_addr * | addr,
|  | bridgeif_portmask_t | ports )

Add a static entry to the forwarding database. A static entry marks where frames to a specific eth address (unicast or group address) are forwarded. bits [0..(BRIDGEIF_MAX_PORTS-1)]: hw ports bit [BRIDGEIF_MAX_PORTS]: cpu port 0: drop

## bridgeif_fdb_remove()

err_t bridgeif_fdb_remove | ( | struct netif * | bridgeif,
|  | const struct eth_addr * | addr )

Remove a static entry from the forwarding database

## bridgeif_init()

err_t bridgeif_init | ( | struct netif * | netif | ) |

Initialization function passed to netif_add().

ATTENTION: A pointer to a bridgeif_initdata_t must be passed as 'state' to netif_add when adding the bridge. I supplies MAC address and controls memory allocation (number of ports, FDB size).

Parameters

  netif | the lwip network interface structure for this ethernetif

Returns
  ERR_OK if the loopif is initialized ERR_MEM if private data couldn't be allocated any other err_t on error